-- saveCrabSteering
--
-- Version 1.0
-- Autor Ralf08
-- 
-- Change log:
-- 10.02.2019 / Ralf08 / first release 

saveCrabSteering = {}

function saveCrabSteering.prerequisitesPresent(specializations)
	--print("saveCrabSteering.prerequisitesPresent(specializations)")
	return true
end;

function saveCrabSteering.registerEventListeners(vehicleType)
	--print("saveCrabSteering.registerEventListeners(vehicleType)")
	for i, v in ipairs({"onPostLoad","saveToXMLFile"}) do
		SpecializationUtil.registerEventListener(vehicleType, v, saveCrabSteering);
	end;
end;


function saveCrabSteering:onPostLoad(savegame)
	--print("saveCrabSteering:onPostLoad()")
	if savegame ~= nil and self.spec_crabSteering.state ~= nil then
	
		local xmlFile = savegame.xmlFile
		local key = savegame.key ..".saveCrabSteering"
		local state = Utils.getNoNil(getXMLInt(xmlFile, key.."#state"),1)
		
		if state ~= self.spec_crabSteering.state then
			
			--fix for VehicleControlAddon
			if self.spec_zzzVehicleControlAddon~= nil then
				for i,w in pairs( self.spec_wheels.wheels ) do 
					if w.rotSpeed ~= nil and w.vcaRotSpeed == nil then 
						w.vcaRotSpeed = w.rotSpeed 
					end; 
			
					if w.rotSpeedNeg ~= nil and w.vcaRotSpeedNeg == nil then 
						w.vcaRotSpeedNeg = w.rotSpeedNeg 
					end;					
				end;
			end;
			
			self:setCrabSteering(state, true)
		end
	end 
end 


function saveCrabSteering:saveToXMLFile(xmlFile, key)
	--print("saveCrabSteering:saveToXMLFile()")
	if self.spec_crabSteering.state ~= nil then
		setXMLInt(xmlFile,  key.."#state", self.spec_crabSteering.state)
	end;
end

